// Requirement
%error = ForceRequiredAddOn("Brick_TilePlates");

if(%error == $Error::AddOn_Disabled || %error == $Error::AddOn_NotFound)
{
	error("ERROR: Brick_Gamblepack - Round tiles not enabled, missing Brick_TilePlates");
}
else
{
	datablock fxDTSBrickData (brickRoundTile1x1fData)
	{
	brickFile = "./Tiles/roundtile_1x1f.blb";
	category = "Plates";
	subCategory = "Tile Plates";
	uiName = "1x1f Round Tile";
	iconName = "Add-ons/Brick_Gamblepack/PNG/4a";
	collisionShapeName = "./DTS/1x1fround.dts";
	};
	
	datablock fxDTSBrickData (brickRoundTile2x2fData)
	{
	brickFile = "./Tiles/roundtile_2x2f.blb";
	category = "Plates";
	subCategory = "Tile Plates";
	uiName = "2x2f Round Tile";
	iconName = "Add-ons/Brick_Gamblepack/PNG/4b";
	collisionShapeName = "./DTS/2x2fround.dts";
	};
	
	// Round corner tiles
	datablock fxDTSBrickData (brickRoundCornerTile1x1fData)
	{
	brickFile = "./Tiles/roundcornertile_1x1f.blb";
	category = "Plates";
	subCategory = "Tile Plates";
	uiName = "1x1f Round Corner Tile";
	iconName = "Add-ons/Brick_Gamblepack/PNG/4e";
	collisionShapeName = "./DTS/roundcornertile_1x1f.dts";
	};
	
	datablock fxDTSBrickData (brickRoundCornerTile2x2fData)
	{
	brickFile = "./Tiles/roundcornertile_2x2f.blb";
	category = "Plates";
	subCategory = "Tile Plates";
	uiName = "2x2f Round Corner Tile";
	iconName = "Add-ons/Brick_Gamblepack/PNG/4f";
	collisionShapeName = "./DTS/roundcornertile_2x2f.dts";
	};
	
	// One random pack requirement
	%error = ForceRequiredAddOn("Brick_1RandomPack");

	if(%error == $Error::AddOn_Disabled || %error == $Error::AddOn_NotFound)
	{
	error("ERROR: Brick_Gamblepack - Extra round tiles not enabled, missing Brick_1RandomPack");
	}
	else
	{
		datablock fxDTSBrickData (brickRoundTile3x3fData)
		{
		brickFile = "./Tiles/roundtile_3x3f.blb";
		category = "Plates";
		subCategory = "Tile Plates";
		uiName = "3x3f Round Tile";
		iconName = "Add-ons/Brick_Gamblepack/PNG/4c";
		collisionShapeName = "./DTS/3x3fround.dts";
		};
		
		datablock fxDTSBrickData (brickRoundTile4x4fData)
		{
		brickFile = "./Tiles/roundtile_4x4f.blb";
		category = "Plates";
		subCategory = "Tile Plates";
		uiName = "4x4f Round Tile";
		iconName = "Add-ons/Brick_Gamblepack/PNG/4d";
		collisionShapeName = "./DTS/4x4fround.dts";
		};
	}
}