// Water //
datablock fxDTSBrickData (brick1x1PseudoWaterData)
{
	brickFile = "./Water/1x1 Water.blb";
	category = "Baseplates";
	subCategory = "Water";
	uiName = "1x1 Pseudo-Water";
	iconName = "Add-Ons/Brick_Gamblepack/PNG/1a";
	alwaysShowWireFrame = true;
};

datablock fxDTSBrickData (brick2x2PseudoWaterData)
{
	brickFile = "./Water/2x2 Water.blb";
	category = "Baseplates";
	subCategory = "Water";
	uiName = "2x2 Pseudo-Water";
	iconName = "Add-Ons/Brick_Gamblepack/PNG/1b";
	alwaysShowWireFrame = true;
};

datablock fxDTSBrickData (brick4x4PseudoWaterData)
{
	brickFile = "./Water/4x4 Water.blb";
	category = "Baseplates";
	subCategory = "Water";
	uiName = "4x4 Pseudo-Water";
	iconName = "Add-Ons/Brick_Gamblepack/PNG/1c";
	alwaysShowWireFrame = true;
};

datablock fxDTSBrickData (brick4xPseudoWaterData)
{
	brickFile = "./Water/4x Water.blb";
	category = "Baseplates";
	subCategory = "Water";
	uiName = "4x Pseudo-Water";
	iconName = "Add-Ons/Brick_Gamblepack/PNG/1c";
	alwaysShowWireFrame = true;
};

datablock fxDTSBrickData (brick4xWaterData)
{
	brickFile = "./Water/4x Water.blb";
	category = "Baseplates";
	subCategory = "Water";
	uiName = "4x Water";
	iconName = "Add-Ons/Brick_Gamblepack/PNG/1c";
   alwaysShowWireFrame = true;
   isWaterBrick = true;
};

datablock fxDTSBrickData (brick1x1WaterData)
{
	brickFile = "./Water/1x1 Water.blb";
	category = "Baseplates";
	subCategory = "Water";
	uiName = "1x1 Water";
	iconName = "Add-Ons/Brick_Gamblepack/PNG/1a";
	alwaysShowWireFrame = true;
	isWaterBrick = true;
};

datablock fxDTSBrickData (brick2x2WaterData)
{
	brickFile = "./Water/2x2 Water.blb";
	category = "Baseplates";
	subCategory = "Water";
	uiName = "2x2 Water";
	iconName = "Add-Ons/Brick_Gamblepack/PNG/1b";
	alwaysShowWireFrame = true;
	isWaterBrick = true;
};
datablock fxDTSBrickData (brick4x4WaterData)
{
	brickFile = "./Water/4x4 Water.blb";
	category = "Baseplates";
	subCategory = "Water";
	uiName = "4x4 Water";
	iconName = "Add-Ons/Brick_Gamblepack/PNG/1c";
	alwaysShowWireFrame = true;
	isWaterBrick = true;
};

// 1x1 Pseudo-water

function brick1x1PseudoWaterData::onPlant(%data, %brick)
{
   %brick.setColliding(0);
   %brick.setRayCasting(0);
   %brick.setShapeFX(0);

   //if we've planted directly on top of an identical water brick, hide it
   if(!isObject($LoadingBricks_Client))
   {
      %count = %brick.getNumDownBricks();
      for(%i = 0; %i < %count; %i++)
      {        
         %downBrick = %brick.getDownBrick(%i);

         if(!isObject(%downBrick.physicalZone))
            continue;

         if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
            %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
            %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
            continue;

         %pos = %brick.getPosition();
         %downBrickPos = %downBrick.getPosition();

         %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
         %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

         if(  %xDelta > 0.05  ||
              %yDelta > 0.05  )
            continue;

         %downBrick.setRendering(0);
      }
   }
}

function brick1x1PseudoWaterData::onLoadPlant(%data, %obj)
{
   brick1x1PseudoWaterData::onPlant(%data, %obj); 
}


function brick1x1PseudoWaterData::onTrustCheckFinished(%data, %brick)
{
   Parent::onTrustCheckFinished(%data, %brick);
   %brick.createWaterZone();  
}


function brick1x1PseudoWaterData::onDeath(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
   
   //unhide water bricks that are directly under this brick
   %count = %brick.getNumDownBricks();
   for(%i = 0; %i < %count; %i++)
   {        
      %downBrick = %brick.getDownBrick(%i);

      if(!isObject(%downBrick.physicalZone))
         continue;

      if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
         %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
         %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
         continue;

      %pos = %brick.getPosition();
      %downBrickPos = %downBrick.getPosition();

      %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
      %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

      if(  %xDelta > 0.05  ||
           %yDelta > 0.05  )
         continue;

      %downBrick.setRendering(1);
   }

}

function brick1x1PseudoWaterData::onRemove(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
}

function brick1x1PseudoWaterData::onColorChange(%data, %brick)
{
   Parent::onColorChange(%data, %brick);
   %color = getColorIDTable(%brick.colorID);
   %rgb = getWords(%color, 0, 2);
   %a = getWord(%color, 3) * 0.75;

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.setWaterColor(%rgb SPC %a);
}

function brick1x1PseudoWaterData::onFakeDeath(%data, %brick)
{
   Parent::onFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.deactivate();
}

function brick1x1PseudoWaterData::onClearFakeDeath(%data, %brick)
{
   Parent::onClearFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

function brick1x1PseudoWaterData::disappear(%data, %brick, %time)
{
   Parent::disappear(%data,%brick,%time);
   if(%time == 0)
   {
      //disappear(0) = instantly re-appear
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.activate();
      %brick.setColliding(0);
      %brick.setRayCasting(0);
   }
   else
   {
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.deactivate();
   }
}

function brick1x1PseudoWaterData::reappear(%data, %brick)
{
   Parent::reappear(%data,%brick);

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

// 2x2 Pseudo-water

function brick2x2PseudoWaterData::onPlant(%data, %brick)
{
   %brick.setColliding(0);
   %brick.setRayCasting(0);
   %brick.setShapeFX(0);

   //if we've planted directly on top of an identical water brick, hide it
   if(!isObject($LoadingBricks_Client))
   {
      %count = %brick.getNumDownBricks();
      for(%i = 0; %i < %count; %i++)
      {        
         %downBrick = %brick.getDownBrick(%i);

         if(!isObject(%downBrick.physicalZone))
            continue;

         if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
            %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
            %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
            continue;

         %pos = %brick.getPosition();
         %downBrickPos = %downBrick.getPosition();

         %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
         %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

         if(  %xDelta > 0.05  ||
              %yDelta > 0.05  )
            continue;

         %downBrick.setRendering(0);
      }
   }
}

function brick2x2PseudoWaterData::onLoadPlant(%data, %obj)
{
   brick2x2PseudoWaterData::onPlant(%data, %obj); 
}


function brick2x2PseudoWaterData::onTrustCheckFinished(%data, %brick)
{
   Parent::onTrustCheckFinished(%data, %brick);
   %brick.createWaterZone();  
}


function brick2x2PseudoWaterData::onDeath(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
   
   //unhide water bricks that are directly under this brick
   %count = %brick.getNumDownBricks();
   for(%i = 0; %i < %count; %i++)
   {        
      %downBrick = %brick.getDownBrick(%i);

      if(!isObject(%downBrick.physicalZone))
         continue;

      if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
         %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
         %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
         continue;

      %pos = %brick.getPosition();
      %downBrickPos = %downBrick.getPosition();

      %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
      %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

      if(  %xDelta > 0.05  ||
           %yDelta > 0.05  )
         continue;

      %downBrick.setRendering(1);
   }

}

function brick2x2PseudoWaterData::onRemove(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
}

function brick2x2PseudoWaterData::onColorChange(%data, %brick)
{
   Parent::onColorChange(%data, %brick);
   %color = getColorIDTable(%brick.colorID);
   %rgb = getWords(%color, 0, 2);
   %a = getWord(%color, 3) * 0.75;

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.setWaterColor(%rgb SPC %a);
}

function brick2x2PseudoWaterData::onFakeDeath(%data, %brick)
{
   Parent::onFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.deactivate();
}

function brick2x2PseudoWaterData::onClearFakeDeath(%data, %brick)
{
   Parent::onClearFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

function brick2x2PseudoWaterData::disappear(%data, %brick, %time)
{
   Parent::disappear(%data,%brick,%time);
   if(%time == 0)
   {
      //disappear(0) = instantly re-appear
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.activate();
      %brick.setColliding(0);
      %brick.setRayCasting(0);
   }
   else
   {
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.deactivate();
   }
}

function brick2x2PseudoWaterData::reappear(%data, %brick)
{
   Parent::reappear(%data,%brick);

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

// 4x4 Pseudo-water

function brick4x4PseudoWaterData::onPlant(%data, %brick)
{
   %brick.setColliding(0);
   %brick.setRayCasting(0);
   %brick.setShapeFX(0);

   //if we've planted directly on top of an identical water brick, hide it
   if(!isObject($LoadingBricks_Client))
   {
      %count = %brick.getNumDownBricks();
      for(%i = 0; %i < %count; %i++)
      {        
         %downBrick = %brick.getDownBrick(%i);

         if(!isObject(%downBrick.physicalZone))
            continue;

         if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
            %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
            %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
            continue;

         %pos = %brick.getPosition();
         %downBrickPos = %downBrick.getPosition();

         %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
         %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

         if(  %xDelta > 0.05  ||
              %yDelta > 0.05  )
            continue;

         %downBrick.setRendering(0);
      }
   }
}

function brick4x4PseudoWaterData::onLoadPlant(%data, %obj)
{
   brick4x4PseudoWaterData::onPlant(%data, %obj); 
}


function brick4x4PseudoWaterData::onTrustCheckFinished(%data, %brick)
{
   Parent::onTrustCheckFinished(%data, %brick);
   %brick.createWaterZone();  
}


function brick4x4PseudoWaterData::onDeath(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
   
   //unhide water bricks that are directly under this brick
   %count = %brick.getNumDownBricks();
   for(%i = 0; %i < %count; %i++)
   {        
      %downBrick = %brick.getDownBrick(%i);

      if(!isObject(%downBrick.physicalZone))
         continue;

      if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
         %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
         %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
         continue;

      %pos = %brick.getPosition();
      %downBrickPos = %downBrick.getPosition();

      %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
      %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

      if(  %xDelta > 0.05  ||
           %yDelta > 0.05  )
         continue;

      %downBrick.setRendering(1);
   }

}

function brick4x4PseudoWaterData::onRemove(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
}

function brick4x4PseudoWaterData::onColorChange(%data, %brick)
{
   Parent::onColorChange(%data, %brick);
   %color = getColorIDTable(%brick.colorID);
   %rgb = getWords(%color, 0, 2);
   %a = getWord(%color, 3) * 0.75;

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.setWaterColor(%rgb SPC %a);
}

function brick4x4PseudoWaterData::onFakeDeath(%data, %brick)
{
   Parent::onFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.deactivate();
}

function brick4x4PseudoWaterData::onClearFakeDeath(%data, %brick)
{
   Parent::onClearFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

function brick4x4PseudoWaterData::disappear(%data, %brick, %time)
{
   Parent::disappear(%data,%brick,%time);
   if(%time == 0)
   {
      //disappear(0) = instantly re-appear
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.activate();
      %brick.setColliding(0);
      %brick.setRayCasting(0);
   }
   else
   {
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.deactivate();
   }
}

function brick4x4PseudoWaterData::reappear(%data, %brick)
{
   Parent::reappear(%data,%brick);

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

// 4x Pseudo-water

function brick4xPseudoWaterData::onPlant(%data, %brick)
{
   %brick.setColliding(0);
   %brick.setRayCasting(0);
   %brick.setShapeFX(0);

   //if we've planted directly on top of an identical water brick, hide it
   if(!isObject($LoadingBricks_Client))
   {
      %count = %brick.getNumDownBricks();
      for(%i = 0; %i < %count; %i++)
      {        
         %downBrick = %brick.getDownBrick(%i);

         if(!isObject(%downBrick.physicalZone))
            continue;

         if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
            %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
            %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
            continue;

         %pos = %brick.getPosition();
         %downBrickPos = %downBrick.getPosition();

         %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
         %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

         if(  %xDelta > 0.05  ||
              %yDelta > 0.05  )
            continue;

         %downBrick.setRendering(0);
      }
   }
}

function brick4xPseudoWaterData::onLoadPlant(%data, %obj)
{
   brick4xPseudoWaterData::onPlant(%data, %obj); 
}


function brick4xPseudoWaterData::onTrustCheckFinished(%data, %brick)
{
   Parent::onTrustCheckFinished(%data, %brick);
   %brick.createWaterZone();  
}


function brick4xPseudoWaterData::onDeath(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
   
   //unhide water bricks that are directly under this brick
   %count = %brick.getNumDownBricks();
   for(%i = 0; %i < %count; %i++)
   {        
      %downBrick = %brick.getDownBrick(%i);

      if(!isObject(%downBrick.physicalZone))
         continue;

      if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
         %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
         %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
         continue;

      %pos = %brick.getPosition();
      %downBrickPos = %downBrick.getPosition();

      %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
      %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

      if(  %xDelta > 0.05  ||
           %yDelta > 0.05  )
         continue;

      %downBrick.setRendering(1);
   }

}

function brick4xPseudoWaterData::onRemove(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
}

function brick4xPseudoWaterData::onColorChange(%data, %brick)
{
   Parent::onColorChange(%data, %brick);
   %color = getColorIDTable(%brick.colorID);
   %rgb = getWords(%color, 0, 2);
   %a = getWord(%color, 3) * 0.75;

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.setWaterColor(%rgb SPC %a);
}

function brick4xPseudoWaterData::onFakeDeath(%data, %brick)
{
   Parent::onFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.deactivate();
}

function brick4xPseudoWaterData::onClearFakeDeath(%data, %brick)
{
   Parent::onClearFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

function brick4xPseudoWaterData::disappear(%data, %brick, %time)
{
   Parent::disappear(%data,%brick,%time);
   if(%time == 0)
   {
      //disappear(0) = instantly re-appear
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.activate();
      %brick.setColliding(0);
      %brick.setRayCasting(0);
   }
   else
   {
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.deactivate();
   }
}

function brick4xPseudoWaterData::reappear(%data, %brick)
{
   Parent::reappear(%data,%brick);

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

// 4x Water

function brick4xWaterData::onPlant(%data, %brick)
{
   %brick.setColliding(0);
   %brick.setRayCasting(0);
   %brick.setShapeFX(2);

   //if we've planted directly on top of an identical water brick, hide it
   if(!isObject($LoadingBricks_Client))
   {
      %count = %brick.getNumDownBricks();
      for(%i = 0; %i < %count; %i++)
      {        
         %downBrick = %brick.getDownBrick(%i);

         if(!isObject(%downBrick.physicalZone))
            continue;

         if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
            %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
            %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
            continue;

         %pos = %brick.getPosition();
         %downBrickPos = %downBrick.getPosition();

         %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
         %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

         if(  %xDelta > 0.05  ||
              %yDelta > 0.05  )
            continue;

         %downBrick.setRendering(0);
      }
   }
}

function brick4xWaterData::onLoadPlant(%data, %obj)
{
   brick4xWaterData::onPlant(%data, %obj); 
}


function brick4xWaterData::onTrustCheckFinished(%data, %brick)
{
   Parent::onTrustCheckFinished(%data, %brick);
   %brick.createWaterZone();  
}


function brick4xWaterData::onDeath(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
   
   //unhide water bricks that are directly under this brick
   %count = %brick.getNumDownBricks();
   for(%i = 0; %i < %count; %i++)
   {        
      %downBrick = %brick.getDownBrick(%i);

      if(!isObject(%downBrick.physicalZone))
         continue;

      if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
         %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
         %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
         continue;

      %pos = %brick.getPosition();
      %downBrickPos = %downBrick.getPosition();

      %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
      %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

      if(  %xDelta > 0.05  ||
           %yDelta > 0.05  )
         continue;

      %downBrick.setRendering(1);
   }

}

function brick4xWaterData::onRemove(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
}

function brick4xWaterData::onColorChange(%data, %brick)
{
   Parent::onColorChange(%data, %brick);
   %color = getColorIDTable(%brick.colorID);
   %rgb = getWords(%color, 0, 2);
   %a = getWord(%color, 3) * 0.75;

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.setWaterColor(%rgb SPC %a);
}

function brick4xWaterData::onFakeDeath(%data, %brick)
{
   Parent::onFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.deactivate();
}

function brick4xWaterData::onClearFakeDeath(%data, %brick)
{
   Parent::onClearFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

function brick4xWaterData::disappear(%data, %brick, %time)
{
   Parent::disappear(%data,%brick,%time);
   if(%time == 0)
   {
      //disappear(0) = instantly re-appear
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.activate();
      %brick.setColliding(0);
      %brick.setRayCasting(0);
   }
   else
   {
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.deactivate();
   }
}

function brick4xWaterData::reappear(%data, %brick)
{
   Parent::reappear(%data,%brick);

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

// 1x1 Water

function brick1x1WaterData::onPlant(%data, %brick)
{
   %brick.setColliding(0);
   %brick.setRayCasting(0);
   %brick.setShapeFX(2);

   //if we've planted directly on top of an identical water brick, hide it
   if(!isObject($LoadingBricks_Client))
   {
      %count = %brick.getNumDownBricks();
      for(%i = 0; %i < %count; %i++)
      {        
         %downBrick = %brick.getDownBrick(%i);

         if(!isObject(%downBrick.physicalZone))
            continue;

         if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
            %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
            %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
            continue;

         %pos = %brick.getPosition();
         %downBrickPos = %downBrick.getPosition();

         %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
         %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

         if(  %xDelta > 0.05  ||
              %yDelta > 0.05  )
            continue;

         %downBrick.setRendering(0);
      }
   }
}

function brick1x1WaterData::onLoadPlant(%data, %obj)
{
   brick1x1WaterData::onPlant(%data, %obj); 
}


function brick1x1WaterData::onTrustCheckFinished(%data, %brick)
{
   Parent::onTrustCheckFinished(%data, %brick);
   %brick.createWaterZone();  
}


function brick1x1WaterData::onDeath(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
   
   //unhide water bricks that are directly under this brick
   %count = %brick.getNumDownBricks();
   for(%i = 0; %i < %count; %i++)
   {        
      %downBrick = %brick.getDownBrick(%i);

      if(!isObject(%downBrick.physicalZone))
         continue;

      if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
         %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
         %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
         continue;

      %pos = %brick.getPosition();
      %downBrickPos = %downBrick.getPosition();

      %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
      %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

      if(  %xDelta > 0.05  ||
           %yDelta > 0.05  )
         continue;

      %downBrick.setRendering(1);
   }

}

function brick1x1WaterData::onRemove(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
}

function brick1x1WaterData::onColorChange(%data, %brick)
{
   Parent::onColorChange(%data, %brick);
   %color = getColorIDTable(%brick.colorID);
   %rgb = getWords(%color, 0, 2);
   %a = getWord(%color, 3) * 0.75;

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.setWaterColor(%rgb SPC %a);
}

function brick1x1WaterData::onFakeDeath(%data, %brick)
{
   Parent::onFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.deactivate();
}

function brick1x1WaterData::onClearFakeDeath(%data, %brick)
{
   Parent::onClearFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

function brick1x1WaterData::disappear(%data, %brick, %time)
{
   Parent::disappear(%data,%brick,%time);
   if(%time == 0)
   {
      //disappear(0) = instantly re-appear
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.activate();
      %brick.setColliding(0);
      %brick.setRayCasting(0);
   }
   else
   {
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.deactivate();
   }
}

function brick1x1WaterData::reappear(%data, %brick)
{
   Parent::reappear(%data,%brick);

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

// 2x2 Water

function brick2x2WaterData::onPlant(%data, %brick)
{
   %brick.setColliding(0);
   %brick.setRayCasting(0);
   %brick.setShapeFX(2);

   //if we've planted directly on top of an identical water brick, hide it
   if(!isObject($LoadingBricks_Client))
   {
      %count = %brick.getNumDownBricks();
      for(%i = 0; %i < %count; %i++)
      {        
         %downBrick = %brick.getDownBrick(%i);

         if(!isObject(%downBrick.physicalZone))
            continue;

         if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
            %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
            %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
            continue;

         %pos = %brick.getPosition();
         %downBrickPos = %downBrick.getPosition();

         %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
         %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

         if(  %xDelta > 0.05  ||
              %yDelta > 0.05  )
            continue;

         %downBrick.setRendering(0);
      }
   }
}

function brick2x2WaterData::onLoadPlant(%data, %obj)
{
   brick2x2WaterData::onPlant(%data, %obj); 
}


function brick2x2WaterData::onTrustCheckFinished(%data, %brick)
{
   Parent::onTrustCheckFinished(%data, %brick);
   %brick.createWaterZone();  
}


function brick2x2WaterData::onDeath(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
   
   //unhide water bricks that are directly under this brick
   %count = %brick.getNumDownBricks();
   for(%i = 0; %i < %count; %i++)
   {        
      %downBrick = %brick.getDownBrick(%i);

      if(!isObject(%downBrick.physicalZone))
         continue;

      if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
         %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
         %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
         continue;

      %pos = %brick.getPosition();
      %downBrickPos = %downBrick.getPosition();

      %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
      %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

      if(  %xDelta > 0.05  ||
           %yDelta > 0.05  )
         continue;

      %downBrick.setRendering(1);
   }

}

function brick2x2WaterData::onRemove(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
}

function brick2x2WaterData::onColorChange(%data, %brick)
{
   Parent::onColorChange(%data, %brick);
   %color = getColorIDTable(%brick.colorID);
   %rgb = getWords(%color, 0, 2);
   %a = getWord(%color, 3) * 0.75;

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.setWaterColor(%rgb SPC %a);
}

function brick2x2WaterData::onFakeDeath(%data, %brick)
{
   Parent::onFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.deactivate();
}

function brick2x2WaterData::onClearFakeDeath(%data, %brick)
{
   Parent::onClearFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

function brick2x2WaterData::disappear(%data, %brick, %time)
{
   Parent::disappear(%data,%brick,%time);
   if(%time == 0)
   {
      //disappear(0) = instantly re-appear
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.activate();
      %brick.setColliding(0);
      %brick.setRayCasting(0);
   }
   else
   {
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.deactivate();
   }
}

function brick2x2WaterData::reappear(%data, %brick)
{
   Parent::reappear(%data,%brick);

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

// 4x4 Water

function brick4x4WaterData::onPlant(%data, %brick)
{
   %brick.setColliding(0);
   %brick.setRayCasting(0);
   %brick.setShapeFX(2);

   //if we've planted directly on top of an identical water brick, hide it
   if(!isObject($LoadingBricks_Client))
   {
      %count = %brick.getNumDownBricks();
      for(%i = 0; %i < %count; %i++)
      {        
         %downBrick = %brick.getDownBrick(%i);

         if(!isObject(%downBrick.physicalZone))
            continue;

         if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
            %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
            %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
            continue;

         %pos = %brick.getPosition();
         %downBrickPos = %downBrick.getPosition();

         %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
         %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

         if(  %xDelta > 0.05  ||
              %yDelta > 0.05  )
            continue;

         %downBrick.setRendering(0);
      }
   }
}

function brick4x4WaterData::onLoadPlant(%data, %obj)
{
   brick4x4WaterData::onPlant(%data, %obj); 
}


function brick4x4WaterData::onTrustCheckFinished(%data, %brick)
{
   Parent::onTrustCheckFinished(%data, %brick);
   %brick.createWaterZone();  
}


function brick4x4WaterData::onDeath(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
   
   //unhide water bricks that are directly under this brick
   %count = %brick.getNumDownBricks();
   for(%i = 0; %i < %count; %i++)
   {        
      %downBrick = %brick.getDownBrick(%i);

      if(!isObject(%downBrick.physicalZone))
         continue;

      if(%downBrick.getDataBlock().brickSizeX != %data.brickSizeX ||
         %downBrick.getDataBlock().brickSizeY != %data.brickSizeY ||
         %downBrick.getDataBlock().brickSizeZ != %data.brickSizeZ )
         continue;

      %pos = %brick.getPosition();
      %downBrickPos = %downBrick.getPosition();

      %xDelta = mAbs(getWord(%pos, 0) - getWord(%downBrickPos, 0));
      %yDelta = mAbs(getWord(%pos, 1) - getWord(%downBrickPos, 1));

      if(  %xDelta > 0.05  ||
           %yDelta > 0.05  )
         continue;

      %downBrick.setRendering(1);
   }

}

function brick4x4WaterData::onRemove(%data, %brick)
{
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.delete();
}

function brick4x4WaterData::onColorChange(%data, %brick)
{
   Parent::onColorChange(%data, %brick);
   %color = getColorIDTable(%brick.colorID);
   %rgb = getWords(%color, 0, 2);
   %a = getWord(%color, 3) * 0.75;

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.setWaterColor(%rgb SPC %a);
}

function brick4x4WaterData::onFakeDeath(%data, %brick)
{
   Parent::onFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.deactivate();
}

function brick4x4WaterData::onClearFakeDeath(%data, %brick)
{
   Parent::onClearFakeDeath(%data, %brick);
   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}

function brick4x4WaterData::disappear(%data, %brick, %time)
{
   Parent::disappear(%data,%brick,%time);
   if(%time == 0)
   {
      //disappear(0) = instantly re-appear
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.activate();
      %brick.setColliding(0);
      %brick.setRayCasting(0);
   }
   else
   {
      if(isObject(%brick.physicalZone))
         %brick.physicalZone.deactivate();
   }
}

function brick4x4WaterData::reappear(%data, %brick)
{
   Parent::reappear(%data,%brick);

   if(isObject(%brick.physicalZone))
      %brick.physicalZone.activate();

   %brick.setColliding(0);
   %brick.setRayCasting(0);
}